package/base-files: add support for the switch LED trigger
[openwrt.git] / package / base-files / files / sbin / sysupgrade
index 0fb0753..fcf01b0 100755 (executable)
@@ -10,6 +10,8 @@ export SAVE_CONFIG=1
 export SAVE_OVERLAY=0
 export DELAY=
 export CONF_IMAGE=
+export CONF_BACKUP=
+export HELP=0
 
 # parse options
 while [ -n "$1" ]; do 
@@ -20,7 +22,9 @@ while [ -n "$1" ]; do
                -q) export VERBOSE="$(($VERBOSE - 1))";;
                -n) export SAVE_CONFIG=0;;
                -c) export SAVE_OVERLAY=1;;
+               -b|--create-backup) export CONF_BACKUP="$2"; shift;;
                -f) export CONF_IMAGE="$2"; shift;;
+               -h|--help) export HELP=1; break;;
                -*)
                        echo "Invalid option: $1"
                        exit 1
@@ -36,7 +40,7 @@ export CONF_TAR=/tmp/sysupgrade.tgz
 export ARGV="$*"
 export ARGC="$#"
 
-[ -z "$ARGV" ] && {
+[ -z "$ARGV" -a -z "$CONF_BACKUP" -o $HELP -gt 0 ] && {
        cat <<EOF
 Usage: $0 [options] <image file or URL>
 
@@ -45,18 +49,36 @@ Options:
        -f <config>  restore configuration from .tar.gz (file or url)
        -i           interactive mode
        -c           attempt to preserve all changed files in /etc/
+       -b / --create-backup <file>
+                    create .tar.gz of files specified in sysupgrade.conf
+                    then exit. Does not flash an image. If file is '-',
+                    i.e. stdout, verbosity is set to 0 (i.e. quiet).
        -n           do not save configuration over reflash
        -q           less verbose
        -v           more verbose
+       -h / --help  display this help
 
 EOF
        exit 1
 }
 
+[ -n "$ARGV" -a -n "$CONF_BACKUP" ] && {
+       cat <<-EOF
+               -b/--create-backup does not perform a firmware upgrade. Do not
+               specify both -b and a firmware image.
+       EOF
+       exit 1
+}
+
+# prevent messages from clobbering the tarball when using stdout
+[ "$CONF_BACKUP" = "-" ] && export VERBOSE=0
+
 add_uci_conffiles() {
        local file="$1"
-       find /etc/config /etc/passwd /etc/group /etc/dropbear \
-               /etc/firewall.user /etc/rc.local -type f > "$file"
+       ( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
+               /etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \
+               -type f 2>/dev/null;
+         opkg list-changed-conffiles ) | sort -u > "$file"
        return 0
 }
 
@@ -80,6 +102,8 @@ sysupgrade_image_check="platform_check_image"
 include /lib/upgrade
 
 do_save_conffiles() {
+       local conf_tar="${1:-$CONF_TAR}"
+
        [ -z "$(rootfs_type)" ] && {
                echo "Cannot save config while running from ramdisk."
                ask_bool 0 "Abort" && exit
@@ -90,9 +114,14 @@ do_save_conffiles() {
 
        v "Saving config files..."
        [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
-       tar c${TAR_V}zf "$CONF_TAR" -T "$CONFFILES" 2>/dev/null
+       tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null
 }
 
+if [ -n "$CONF_BACKUP" ]; then
+       do_save_conffiles "$CONF_BACKUP"
+       exit $?
+fi
+
 type platform_check_image >/dev/null 2>/dev/null || {
        echo "Firmware upgrade is not implemented for this platform."
        exit 1
@@ -122,8 +151,13 @@ elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
 else
        export SAVE_CONFIG=0
 fi
+
 run_hooks "" $sysupgrade_pre_upgrade
 
+kill_remaining TERM
+sleep 3
+kill_remaining KILL
+
 if [ -n "$(rootfs_type)" ]; then
        v "Switching to ramdisk..."
        run_ramfs '. /etc/functions.sh; include /lib/upgrade; do_upgrade'
This page took 0.028687 seconds and 4 git commands to generate.